#!/bin/sh
#########################################################################
# File Name: iot_iptables_ports.sh
# Created Time: Thu Aug  1 10:58:47 2019
#########################################################################

readonly opt="$1"
readonly user_filter_chain="IOTP_INPUT_CHAIN"
readonly IPTABLES_PORTS_LIST="/iotp/etc/sysconfig/iptables_ports_list.ini"

enable_port()
{
	local _proto="$1"
	local _port="$2"

	test -z "${_proto}" && return 1
	test -z "${_port}" && return 1

	local _rule="-p ${_proto} --dport ${_port} -j ACCEPT"

	# 检查端口在不在
	(iptables -C ${user_filter_chain} ${_rule} > /dev/null 2>&1)
	if [ "$?" -ne 0 ];then
		# 添加端口和协议
		iptables -A ${user_filter_chain} ${_rule} > /dev/null 2>&1
		return $?
	fi

	return 1
}

# 创建自定义IOT链
iptables -t filter -N ${user_filter_chain} > /dev/null 2>&1

# 自定义链进行清理
if [[ "${opt}" == "refresh" ]];then
	iptables -t filter -F ${user_filter_chain}
fi

# iot mosquitto
enable_port tcp 58883
# iot lora_server
enable_port tcp 58967
# iot web
enable_port tcp 57999
# iot gw_discover
enable_port udp 58601
# iot 摄像头
enable_port udp 58602
# iot dc_package
enable_port tcp 58002
# iot third-server poe udp
enable_port udp 58004
enable_port tcp 58004
# direct
enable_port udp 58863
enable_port tcp 58863
# iot third-server poe tcp
enable_port tcp 58003
# iot third-server direct tcp

#
#while read proto port
#do
#	enable_port "${proto}" "${port}"
#done < ${IPTABLES_PORTS_LIST}
#

(iptables -C INPUT -t filter -j ${user_filter_chain} > /dev/null 2>&1)
if [ "$?" -ne 0 ];then
	iptables -t filter -I INPUT -j ${user_filter_chain}
fi

