#!/bin/bash

APPNAME="${1:-device_handler}"

APPCLI=/iotp/sbin/appinit_cli
WAITTIME=10

APPPID=$(${APPCLI} info | grep "$APPNAME" | awk '{print $1}')

[ -z "$APPPID" ] && exit 0
if [ "$APPPID" = "-1" ]; then
	${APPCLI} start "$APPNAME"
else
	${APPCLI} restart "$APPNAME"
	wait_10sec=0
	while [ -f "/proc/${APPPID}/cmdline" ] && cat /proc/${APPPID}/cmdline | grep -q "$APPNAME" ;
	do
		sleep 0.3s
		wait_10sec=$((wait_10sec+1))
		[ $wait_10sec -gt $((WAITTIME*10)) ] && break
	done
	[ $wait_10sec -gt $((WAITTIME*10)) ] && kill -9 $APPPID 
fi

